---
titleEN: Economy, Environment and Sustainability
title: 经济，环境可持续性
date: 2019-02-28
categories:
- thoughts
tags:
- development
- environment
---

{% raw %}<span class=".zh">{% endraw %}

经济学是一门研究选择的学问。人们活在世上总是在进行着各种选择。发展落后的国家希望尽快工业化发展经济，来改善自己的生存环境。而工业化后的国家则希望发展同时兼顾环境。于是落后国家需要50年来发展工业，搞基建，破坏环境。之后的50年则拼命治理环境，发展生态。由于地球生态是一个整体，发达国家非常不爽落后的国家搞工业化污染环境，于是各种矛盾。不过在21世纪，有望利用信息数字科技打破50-50年法则，为新一批的国家崛起提供蹊径( ๑´•ω•) "
{% raw %}</span>{% endraw %}


{% raw %}<span class=".en">{% endraw %}
Economics is a study of choice. People are always making various choices in the world. Countries that are underdeveloped hope to industrialize and develop their economy as soon as possible to improve their living environment. The post-industrial countries hope to develop while taking the environment into consideration. So backward countries need 50 years to develop industry, engage in infrastructure construction, and destroy the environment. For the next 50 years, he worked hard to control the environment and develop the ecology. Because the earth's ecology is a whole, developed countries are very upset and backward countries are engaged in industrialization and polluting the environment, so various contradictions arise. However, in the 21st century, it is expected to use information and digital technology to break the 50-50 year rule and provide a path for the rise of a new group of countries (๑´•ω•) "

{% raw %}</span>{% endraw %}

<!--more-->

{% raw %}
<script>
	session.onload(function(){
		if(page.tran.getLang() == 'en'){
			tips.warning({
				title: 'Caution',
				position: 'topRight',
				message: 'This page was translated by Machine!!',
				buttons: [['<button>Show Original Page</button>', function (instance, toast) {
					page.tran.setLang('zh');
             		instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
        		}, true]]
			});
		}
	});
</script>
{% endraw %}

{% raw %}<span class=".zh">{% endraw %}

## 为什么追求发展

自然环境较为恶劣，不完全适合人类生存。于是具备主观能动性的人类开始由改造环境的冲动。这一心理行为逐步早就了名为“发展”的宏伟故事，大家都对其深信不已。就像故事中所描述的一样，人们为了实现这一目标开始减少内耗（战争），社会趋于高度分工化。

人类有一种基本心理效应叫蔡格尼克效应，讲的是人如果开始做一件事情便会难以在中途停下来。这一效应在群体行为中则会变本加厉的体现。当人们开始追求发展，并且得到了一定的激励（生活的确更舒适了，至少人们是这样认为的），于是这个势头便不会轻易停下来了，于是人类进入了千年级别的发展时期。

发展初期，太多的基础设施需要建设，太多的工业需要发展，最重要的是这个时候大家都很穷，都只是在一个信念的支撑下在向着发展的目标努力搞生产。而且一般当这个时候，往往会有其他强国对你虎视眈眈，所以这个时候，大家都会很团结，但不会像祖先以及后辈一样在乎什么环境生态的。只有一个想法便是希望发展起来。

经过大约50年的发展，生活好了，底气足了，开始关注一些更长久的事情，比如教育和环境。于是接下来的50年，开始拼命治理环境，搞教育。于是渐渐的环境好了，下一代也成长起来了。于是年轻一代们便利用他们头脑中的书本知识，开始批判祖先们破坏环境这不好那不好，开始投科研资金，股市凡是跟环保相关的板块开始居高不下，可持续发展开始成为许多人的口头禅。而这时，当时那些破坏环境的罪魁祸首们正退休在家里乐呵呵的看着这一切的发生。大概就是这么一个过程了。


## Environmental Kuznet Curve

![Environmental Kuznet Curve][1]

上图的曲线非常科学地向我们展示出了一个国家在发展与环境之间摇摆的必然趋势。在这一图表的背后，反应出了以下几点：
 - 人们倾向于只考虑自己的假设
 - 不同于个体的人群特性
 - 生存资源稀缺
 - 生产资料流通低效

这意味着，如果能够改变上述的任何一个条件，Kuznet 诅咒便有希望得以改变，从而减小摆动周期和幅度，控制环境重建与修复成本，真正在宏观上实现人们所希望的高效率可持续发展。而新一代的数字信息技术正是这一可能性得以实践的关键。

## 概念图
{% raw %}
<!-- 引入mermaid制图-->
<div class="mermaid">
graph TD
A{Environment}
B{Economy}
C{Society}

D[GDB Based]
E[NNI** HDI]
F[Kuznet Curve]
G[Env Kuznet Curve]

H((Human Nature))

I[Human Behavior]
J[Improve Living Environment]
K[Request for Dev]

A --> J
J --> K
K --> B
B --> |measured by| D
D --> |neglect| C
B --> |predicted by| F
F --> C
D --> |foments| I
D --> |spoils| A
G --> C
H --> I
E --> |consider| A
B --> E
A --> H
I --> |caused by| C
I --> A

</div>
{% endraw %}

--------------------------------
**参考课件：**
[Economic Development and The Environment.pdf][2]


  [1]: https://api.yimian.xyz/img/?path=imgbed/img_d6d943f_299x169_8_null_normal.jpeg
  [2]: https://yimian-attachment.obs.myhwclouds.com/ppt/lan104/Week%202%20Economic%20Development%20%20The%20Environment.pdf


{% raw %}</span>{% endraw %}

{% raw %}<span class=".en">{% endraw %}

## Why pursue development

The natural environment is relatively harsh and not entirely suitable for human survival. Therefore, human beings with subjective initiative begin to change the environment from the impulse. This psychological behavior gradually resulted in a magnificent story called "development", and everyone was convinced of it. As described in the story, in order to achieve this goal, people begin to reduce internal friction (war), and society tends to be highly divided.

Human beings have a basic psychological effect called the Zeignik effect, which means that if a person starts to do something, it will be difficult to stop in the middle. This effect will be intensified in group behavior. When people start to pursue development, and get a certain amount of incentives (life is indeed more comfortable, at least people think so), then this momentum will not easily stop, so mankind has entered a millennium-level development period.

In the early stages of development, too much infrastructure needs to be built, too much industry needs to be developed, and the most important thing is that everyone is very poor at this time, and they are only working hard towards the goal of development under the support of a belief. And generally at this time, there will often be other powerful countries looking at you, so at this time, everyone will be very united, but they will not care about the environment and ecology like their ancestors and descendants. There is only one idea that I hope to develop.

After about 50 years of development, my life is better and I am more confident, and I start to pay attention to some longer-term things, such as education and the environment. So in the next 50 years, I began to work hard to improve the environment and engage in education. As a result, the environment gradually improved, and the next generation grew up. So the younger generation made use of the book knowledge in their minds and began to criticize their ancestors for destroying the environment, which is not good or not, and began to invest in scientific research funds. The stock market began to remain high in environmental protection-related sectors, and sustainable development began to become many people. Mantra. At this time, the culprits who were damaging the environment at that time were retiring at home and happily watching this happen. It's probably such a process.


## Environmental Kuznet Curve

![Environmental Kuznet Curve][1]

The curve in the figure above shows us very scientifically the inevitable trend of a country swinging between development and the environment. Behind this chart, the following points are reflected:
 - People tend to only consider their own assumptions
 - Different from individual characteristics of the population
 - Survival resources are scarce
 - Inefficient circulation of production materials

This means that if any of the above conditions can be changed, the Kuznet curse will hopefully be changed, thereby reducing the swing cycle and amplitude, controlling the cost of environmental reconstruction and restoration, and truly achieving the high-efficiency and sustainable development that people hope on the macro level. . The new generation of digital information technology is the key to this possibility.

## Concept map
{% raw %}
<!-- Introduce mermaid drawing-->
<div class="mermaid">
graph TD
A{Environment}
B{Economy}
C{Society}

D[GDB Based]
E[NNI** HDI]
F[Kuznet Curve]
G[Env Kuznet Curve]

H((Human Nature))

I[Human Behavior]
J[Improve Living Environment]
K[Request for Dev]

A --> J
J --> K
K --> B
B --> |measured by| D
D --> |neglect| C
B --> |predicted by| F
F --> C
D --> |foments| I
D --> |spoils| A
G --> C
H --> I
E --> |consider| A
B --> E
A --> H
I --> |caused by| C
I --> A

</div>
{% endraw %}

--------------------------------
**Reference Courseware:**
[Economic Development and The Environment.pdf][2]


  [1]: https://api.yimian.xyz/img/?path=imgbed/img_d6d943f_299x169_8_null_normal.jpeg
  [2]: https://yimian-attachment.obs.myhwclouds.com/ppt/lan104/Week%202%20Economic%20Development%20%20The%20Environment.pdf

{% raw %}</span>{% endraw %}
