---
title: 气候变化与全球环境
titleEN: Climate change and the global environment
display: true
date: 2019-02-27
categories:
- thoughts
tags:
- climate
- environment
---



{% raw %}<span class=".zh">{% endraw %}
全球气候变化与人类行为有着显著的相关性，人类行为又会改变气候的自然变化。通过研究Ice core等Archive，发现地球历史中温度与$CO_{2}$浓度有着显著正相关性。如今，人类行为使大气$CO_{2}$含量远超其正常水平，其可能引起全球变暖，冰川融化等，但仅为可能..
{% raw %}</span>{% endraw %}


{% raw %}<span class=".en">{% endraw %}
Global climate change has a significant correlation with human behavior, and human behavior will change the natural changes in climate. By studying Archives such as Ice core, it is found that there is a significant positive correlation between the temperature and the concentration of $CO_{2}$ in the history of the earth. Nowadays, human behavior makes the atmospheric content of $CO_{2}$ far exceed its normal level, which may cause global warming, melting of glaciers, etc., but it is only possible...

{% raw %}</span>{% endraw %}


<!--more-->

{% raw %}
<script>
	session.onload(function(){
		if(page.tran.getLang() == 'en'){
			tips.warning({
				title: 'Caution',
				position: 'topRight',
				message: 'This page was translated by Machine!!',
				buttons: [['<button>Show Original Page</button>', function (instance, toast) {
					page.tran.setLang('zh');
             		instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
        		}, true]]
			});
		}
	});
</script>
{% endraw %}

{% raw %}<span class=".zh">{% endraw %}
## 概念简介

### 天气与气候
天气是指一段较短时间段内的大气状态，而气候研究的主要使更长时间中周期行动大气状态规律。简言之，气候是周期变化的天气。气候具备地域性，随纬度与海陆分布密切相关。在更长的时间维度上，我们发现地球的气候变迁也呈现出显著的周期性。

![地球历史温度变迁][2]

上图描述了地球的历史温度，其具有明显的周期性。值得注意的是，每当全球气候变暖，便会激发物种爆炸。而现在，正处于一次小规模的温度上升期，且温度上升速度与历史数据并无太大异常，因此无法确凿证明其与人类二氧化碳排放有关。

## 研究方法

### 直接法（研究现代）
1. 记录温度
2. 记录降雨量 (Precipitation)
3. 研究植被 (Vegetation)
4. 海平面
5. 冰川 (Glaciers) :: 主要通过研究冰盖融化与生成的Balance

### 间接法（研究历史）
1. Proxy
2. Archive e.g. "Ice Core" ::从冰层(Ice Sheet)中提取的分层的冰棍标本

### Ice Core分层原因
积雪后，随着时间推移，积雪会经历以下几种状态：
1. Snow (几小时，主要成分是空气)
2. Firn (几天，粒雪)
3. Glacial Ice (数年)

### 时间追溯方法
由于积雪时的温度不同，因此冰层中会以年为单位周期变化，通过计数层数即可获得某一冰层的所属年代。
![冰层][3]

### 历史温度研究方法
大气中${}^{18}O/{}^{16}O$比值与温度密切相关，因此通过测量冰层中相应位置的同位素比值即可间接推得当时的温度。
此外，还可以通过类似的方法测得各历史时期的$CO_{2}$浓度。

## 研究发现

### 二氧化碳浓度与温度密切相关

![历史二氧化碳与温度][4]

由上图可看出，地球历史上，二氧化碳浓度与温度具备密切的相关性。直到近150年，这一规律被打破，大气二氧化碳浓度极具上升。人表示慌得一批⌇●﹏●⌇

## 与人类

### 一个公式
$$Increase CO_{2} = Increasing Population + \Delta Emission per Person + Efficiency of CO_{2} Use$$
这个公式也可以转译为:
$$碳排量 = 人口 + 经济 - 科技$$

### 一个组织
Intergovernmental Panel on Climate Change (IPCC) 制定了一个小目标来限制各国温室气体排放，表示到2050年，全球二氧化碳排放量要卡一半。。这其实等同于将排放量和钱联系起来，给每个国家分一部分排放量，如果多排就要交钱来买。结果已经工业化完的发达国家切走了超过40%的蛋糕，国科大校长老丁表示这不能忍啊，发展中国家的人到底还有没有人权啊ヾ(´･ ･｀｡)ノ"

## 气候变暖影响
### Good
 - 数据表明温度越高，世界范围战争数量越少
 - 实验表明，温度高时，粮食等植被产量更高

### Bad
 - 南方动物（虫子）比植物北迁的快，北方无天敌，植物被虫子吃光
 - 海平面上升，淹没苏州

{% raw %}
<!-- 引入mermaid制图-->
<div class="mermaid">
graph TD
A{Climate Change}
B[Economy]
C[Politic]
D[Tech]
E[Agriculture]
F[Human Health]

A --> |influence| E
E --> |change| B
E --> |change| C
B --> |change| C
B --> |determine| D
C --> |determine| D
B --> |influence| F
D --> |affect| F
D --> A
C --> A
D --> E
E --> |Green Plant| A
E --> F
F --> E
</div>
{% endraw %}

-------------
参考课件：
[Climate change - From past to Future - Yi Zou-2019.pdf][1]


  [1]: https://www.eee.dog/usr/uploads/2019/02/3411175553.pdf
  [2]: https://api.yimian.xyz/img/?path=imgbed/img_8a6ca9c_720x237_8_null_normal.jpeg
  [3]: https://api.yimian.xyz/img/?path=imgbed/img_c2461c9_600x400_8_null_normal.jpeg
  [4]: https://api.yimian.xyz/img/?path=imgbed/img_d2a8246_394x204_8_null_normal.jpeg

 {% raw %}</span>{% endraw %}

{% raw %}<span class=".en">{% endraw %}

## Concept introduction

### Weather and Climate
Weather refers to the state of the atmosphere in a short period of time, and climate research mainly focuses on the law of atmospheric state in a longer period of time. In short, climate is weather that changes periodically. The climate is regional and closely related to the distribution of land and sea with latitude. In a longer time dimension, we find that the Earth’s climate change also shows significant periodicity.

![The temperature changes in the history of the earth][2]

The figure above describes the historical temperature of the earth, which has obvious periodicity. It is worth noting that whenever the global climate warms, it will trigger an explosion of species. But now, it is in a small-scale temperature rise period, and the temperature rise rate is not too abnormal with historical data, so it is impossible to conclusively prove that it is related to human carbon dioxide emissions.

## research method

### Direct method (research modern)
1. Record the temperature
2. Record rainfall (Precipitation)
3. Research vegetation (Vegetation)
4. Sea level
5. Glaciers :: Balance, mainly through the study of the melting and formation of ice sheets

### Indirect Method (Research History)
1. Proxy
2. Archive e.g. "Ice Core" :: a layered ice lolly specimen extracted from the Ice Sheet

### Ice Core layering reasons
After snow cover, over time, snow cover will experience the following states:
1. Snow (a few hours, the main component is air)
2. Firn (a few days, snow)
3. Glacial Ice (several years)

### Time tracking method
Because the temperature of snow is different, the ice layer will change periodically in units of years, and the age of a certain ice layer can be obtained by counting the number of layers.
![冰层][3]

### Historical temperature research method
The ratio of ${}^{18}O/{}^{16}O$ in the atmosphere is closely related to temperature. Therefore, the current temperature can be indirectly inferred by measuring the isotope ratio of the corresponding position in the ice layer.
In addition, the concentration of $CO_{2}$ in each historical period can also be measured by a similar method.

## The study found

### Carbon dioxide concentration is closely related to temperature

![History of carbon dioxide and temperature][4]

As can be seen from the above figure, in the history of the earth, the concentration of carbon dioxide has a close correlation with temperature. Until the past 150 years, this rule was broken, and the concentration of atmospheric carbon dioxide increased dramatically. People expressed panic ⌇●﹏●⌇

## With humans

### A formula
$$Increase CO_{2} = Increasing Population + \Delta Emission per Person + Efficiency of CO_{2} Use$$
This formula can also be translated as:
$$Carbon emissions = population + economy-technology$$

### An organization
The Intergovernmental Panel on Climate Change (IPCC) has set a small goal to limit greenhouse gas emissions in various countries, stating that by 2050, global carbon dioxide emissions will have to be half. . In fact, this is equivalent to linking emissions with money, giving each country a portion of the emissions, and paying for more emissions. As a result, the industrialized developed countries cut away more than 40% of the cake. The president of the National University of Science and Technology, Lao Ding, said that this is unbearable. Do people in developing countries have human rights? ヾ(´･ ･｀｡)ノ"

## Climate warming impact
### Good
 - Data shows that the higher the temperature, the fewer wars worldwide
 - Experiments show that when the temperature is high, the yield of vegetation such as grain is higher

### Bad
 - Southern animals (bugs) move northward faster than plants. There are no natural enemies in the north, and plants are eaten up by bugs.
 - Sea level rises, flooding Suzhou

{% raw %}
<!-- Introduce mermaid drawing-->
<div class="mermaid">
graph TD
A{Climate Change}
B[Economy]
C[Politic]
D[Tech]
E[Agriculture]
F[Human Health]

A --> |influence| E
E --> |change| B
E --> |change| C
B --> |change| C
B --> |determine| D
C --> |determine| D
B --> |influence| F
D --> |affect| F
D --> A
C --> A
D --> E
E --> |Green Plant| A
E --> F
F --> E
</div>
{% endraw %}

-------------
Reference courseware:
[Climate change-From past to Future-Yi Zou-2019.pdf][1]


  [1]: https://www.eee.dog/usr/uploads/2019/02/3411175553.pdf
  [2]: https://api.yimian.xyz/img/?path=imgbed/img_8a6ca9c_720x237_8_null_normal.jpeg
  [3]: https://api.yimian.xyz/img/?path=imgbed/img_c2461c9_600x400_8_null_normal.jpeg
  [4]: https://api.yimian.xyz/img/?path=imgbed/img_d2a8246_394x204_8_null_normal.jpeg



{% raw %}</span>{% endraw %}
