---
title: 人类的两个基本需求
titleEN: Two Fundamental Demands of Human Beings
date: 2018-12-23
display: true
categories:
- thoughts
tags:
- society
---


{% raw %}<span class=".zh">{% endraw %}
人类的需求可以总结为两类，创造需求的需求，与解决需求的需求。


{% raw %}</span>{% endraw %}


{% raw %}<span class=".en">{% endraw %}
Human needs can be summarized into two categories, the need to create needs, and the need to solve needs.
{% raw %}</span>{% endraw %}


<!--more-->

{% raw %}
<script>
	session.onload(function(){
		if(page.tran.getLang() == 'en'){
			tips.warning({
				title: 'Caution',
				position: 'topRight',
				message: 'This page was translated by Machine!!',
				buttons: [['<button>Show Original Page</button>', function (instance, toast) {
					page.tran.setLang('zh');
             		instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
        		}, true]]
			});
		}
	});
</script>
{% endraw %}

{% raw %}<span class=".zh">{% endraw %}

## 历史缘由

在过去的几亿年中，由于生存资源的稀缺，自然界不断通过“物竞天择，适者生存”的法则筛选物种。这使得“一切为了生存”成为了几乎所有物种的“目标函数”。在众多存活下来的物种中，只有人类创造并有效利用了语言这一工具。语言使得人类能够进行更加复杂的推理思维（想象）以及更加有效的个体间信息交流。得益于语言，人类机智地通过预测潜在的自然选择要求提前准备必要的生存资源并建立了协调资源创造（分工）与资源分配的有效体制（市场，贸易）。不可避免地，基于“一切为了生存”这一习惯以及想象与预测这一种能力，人类形成了自主创造需求以及解决需求的行为模式，由此产生了两种基本行为动机，即创造需求的需求与解决需求的需求。

## 理论验证

观察现有人类社会架构，无论社会群体形态是政府，社会组织还是企业（公司），其本质都是一个协调不同人类创造需求的需求与解决需求的需求的闭环生态中的一环。如果一个政府，社会组织或企业无法再继续充当好一个协调人类需求中的闭环生态的一个环节，它将迅速的被其它能更高效发挥其角色的同类或非同类社会群体替代掉。

马云是一位伟大的企业家与战略家，他一手缔造的淘宝电商平台与移动快捷支付使得人们创造需求的需求与解决需求的需求的协调变得更加高效。这使阿里巴巴获得了极大的群众的信任，表现出来就是阿里具备的极高的资源支配权，也就是其极高的市值。

## 理论预测

当人类内部的资源因为某种原因（生产或流通环节出问题）不足以支持所有人的生存时，多余出的人类数量总会以某种形式被抹掉，也就是著名的马尔萨斯陷阱。当一个国家或民族自身遭遇马尔萨斯陷阱时，它总会选择向外发动战争来解决。因为既然要抹掉的人口数量是相对固定的，那么如果向外发动战争就会有更多的本族或本国人能够活下来，只是要将部分的死亡转移至外邦人口。古时的匈奴，二战的德国和日本都是非常典型的例子。

观察历史上的战争，有两次规模很大，我们称之为第一，二次世界大战。第一次世界大战是由于大批量机器取代人力，使得大量原有人力劳动力需要转移。但是劳动力太多没办法短时间转移，表现出来就是失业率飞涨，太多的人无所事事，没有收入，难以生存。为了防止这部分劳动力失控闹事，只得转移其注意力向外发动战争。这就是协调人创造需求的需求与满足需求的需求的市场体制出问题所导致的资源流通停滞所导致的。二战亦是如此，当电力驱动将以往的蒸汽驱动取代，大量劳动力亟需转型。1933年美国率先出现此类问题，罗斯福政府因为有多年发展积累下来的资本，因此可以通过新政建设大量民用设置强行修正资源流通生态链。但是刚因为一战被洗劫一空的德国和国土狭小资源稀缺的日本就没这么幸运了，只得将自身不可避免的马尔萨斯陷阱向犹太人和东亚转移。

如今计算技术充分发展，出现了可以通过建立多项式来fit自然复杂函数（自然规律）的人工智能算法。这就使得大多数非创造型的脑力劳动具备被取代的趋势。那么，这部分原脑力劳动力将何去何从？尤其是在中国和印度这种人口大国，一旦劳动力转型过渡不好，产生的马尔萨斯陷阱代价都将是巨大的，并最终总会由全球承担。

我的想法是，得益于数字技术的发展，如果如今的我们能够创造出一个能够协调人们创造需求的需求与解决需求的需求的闭环生态系统呢？如果当脑力劳动力被替代时这些原有劳动力能够迅速进入并适应我们创立好的闭环生态系统呢？也许我们便能够避开可怕的马尔萨斯陷阱了。

经过几千年文明的发展，当代人类已经不再满足于单单解决自然界所需要的要求，而开始尝试并创造一些非常炫酷有意思但并不怎么有利于生存的需求。也就是说，我们并不在需要所有的人类都要努力工作来确保人类能够生存，我们可以空余出好大一部分人类来探索一些新的有意思的领域。

一个可能的想法是，沉浸型网络游戏。这种网络游戏不同于现有的大部分网络游戏。现有的游戏的商业模式大都是通过程序上限制用户的部分功能体验，只用交了钱的用户才能够使用这些功能。但是我所设想的游戏更像一个平台，玩家可以从中提出自己创造的（游戏中的）需求也可以解决其他人的需求（即交易）。这就意味着一个游戏中可以出现虚拟货币，并且游戏的公众认可度会通过游戏货币与现实货币的汇率得以体现。游戏的开发者将通过开源社区而非企业进行开发，这就意味着开发者与游戏一定程度上非利益相关，从而确保了游戏的纯洁与高效，使之可能具备成为社会基础架构形式的潜能。

游戏的低门槛性并且游戏符合脑力工作者的思维习惯，使脑力劳动力能够比较轻易的从原有职业转移至相应的沉浸式游戏中。并且，由于是虚拟化技术，游戏有充分的弹性容纳大量新增的人们。不同与现在，届时社会舆论与社会思维也将会掀起一股以转入游戏为荣的热潮，以规避危害更大的战争。

有点类似于编程中的函数封装观点，现实社会类似于main函数，各个浸入式网络游戏类似于子函数。现在的社会就像是一个只有main函数的程序，所有的功能都在main函数中实现。这就使得当程序功能越复杂，越有可能发生各种bug，表现出来就是冲突甚至战争。而未来的社会更像是包含好多子函数（沉浸式游戏）的main函数。各个函数都是相互独立而又相互依赖的，每个游戏可以协调好自己的闭环生态，同时又与main函数发生部分交互。这样的社会架构将会变的去中心化并且看上去更加稳定与高效。

-----------------
注：部分想法启发自[知乎][1]


  [1]: https://www.zhihu.com/


{% raw %}</span>{% endraw %}

{% raw %}<span class=".en">{% endraw %}

## Historical reasons

In the past hundreds of millions of years, due to the scarcity of survival resources, nature has constantly selected species through the law of "natural selection by nature, survival of the fittest". This makes "all for survival" the "objective function" of almost all species. Among the many surviving species, only humans have created and effectively used language as a tool. Language enables humans to carry out more complex reasoning thinking (imagination) and more effective communication of information between individuals. Thanks to language, human beings wittily prepare necessary survival resources in advance by predicting potential natural selection requirements and establish an effective system (market, trade) that coordinates resource creation (division of labor) and resource allocation. Inevitably, based on the habit of “everything for survival” and the ability to imagine and predict, human beings have formed a behavioral pattern that independently creates needs and solves needs, which results in two basic behavior motives, namely, the need to create needs. And the need to solve the needs.

## Theoretical verification

Observing the existing human social structure, whether the social group is a government, a social organization or an enterprise (company), its essence is a part of a closed-loop ecology that coordinates the needs of different human creation needs and the needs of solving needs. If a government, social organization, or enterprise can no longer serve as a link in a closed-loop ecology that coordinates human needs, it will quickly be replaced by other similar or different social groups that can perform its role more efficiently.

Jack Ma is a great entrepreneur and strategist. The Taobao e-commerce platform and mobile fast payment created by him have made the coordination of people's demand creation and demand resolution more efficient. This has enabled Alibaba to gain the trust of the masses, which is manifested in the extremely high resource control power that Alibaba possesses, which is its extremely high market value.

## Theoretical prediction

When the internal resources of human beings are insufficient to support the survival of all people for some reason (problems in production or circulation), the excess human population will always be erased in some form, which is the famous Malthus trap. When a country or nation encounters the Malthusian trap, it will always choose to launch a war to solve it. Since the number of people to be erased is relatively fixed, if a war is launched, more people of their own tribe or country will survive, but part of the death will be transferred to the Gentile population. The Huns in ancient times, Germany and Japan in World War II are all very typical examples.

Observing the wars in history, there were two large-scale wars, which we call the First and Second World Wars. The First World War was due to the replacement of manpower by a large number of machines, which necessitated the transfer of a large number of original manpower and labor. However, there is too much labor force to transfer in a short time. It shows that the unemployment rate is soaring, too many people have nothing to do, no income, and it is difficult to survive. In order to prevent this part of the labor force from getting out of control and making trouble, they had to divert their attention and start wars. This is caused by the stagnation of resource circulation caused by problems in the market system that coordinates the needs of people to create needs and meet the needs of needs. The same was true in World War II. When electric drives replaced the previous steam drives, a large number of laborers needed to be transformed. The United States took the lead in such problems in 1933. Because the Roosevelt administration had capital accumulated over the years of development, it was able to forcibly modify the ecological chain of resource circulation through the construction of a large number of civilian settings through the New Deal. However, Germany, which was looted just because of the First World War, and Japan, with its small territory and scarce resources, were not so lucky. They had to transfer their inevitable Malthusian trap to Jews and East Asia.

Now that computing technology is fully developed, artificial intelligence algorithms that can fit natural complex functions (laws of nature) by building polynomials have emerged. This makes most non-creative mental work tend to be replaced. So, where will this part of the original mental workforce go? Especially in populous countries such as China and India, once the transition of the labor force is not good, the cost of the Malthusian trap will be huge and will eventually be borne by the world.

My idea is, thanks to the development of digital technology, what if we can create a closed-loop ecosystem that can coordinate people's needs to create needs and needs to solve them? What if these original labor forces can quickly enter and adapt to the closed-loop ecosystem that we have created when the mental labor is replaced? Maybe we can avoid the terrible Malthus trap.

After thousands of years of civilization development, contemporary mankind is no longer satisfied with simply solving the needs of nature, but has begun to try and create some very cool and interesting needs that are not very conducive to survival. In other words, we do not need all humans to work hard to ensure that they can survive. We can spare a large part of humans to explore some new and interesting fields.

One possible idea is immersive online games. This online game is different from most existing online games. The business models of existing games mostly restrict the user's part of the functional experience through the program, and only users who have paid can use these functions. But the game I envision is more like a platform, from which players can propose their own (in-game) needs and can also solve other people's needs (ie transactions). This means that virtual currency can appear in a game, and the public recognition of the game will be reflected in the exchange rate between the game currency and the real currency. Game developers will develop through open source communities rather than enterprises, which means that the developers are not related to the game to a certain extent, thus ensuring the purity and efficiency of the game and making it possible to become a form of social infrastructure.

The low threshold of the game and the game conforms to the thinking habits of brain workers, so that the mental labor force can be relatively easily transferred from the original occupation to the corresponding immersive game. Moreover, due to the virtualization technology, the game has sufficient flexibility to accommodate a large number of new people. Different from the present, public opinion and social thinking will also set off a wave of pride in transitioning to the game, in order to avoid more harmful wars.

A bit similar to the view of function encapsulation in programming, the real world is similar to the main function, and each immersive online game is similar to sub-functions. The current society is like a program with only the main function, all functions are implemented in the main function. This makes the more complex the program functions, the more likely it is that various bugs will occur, which manifests as conflict or even war. And the future society is more like a main function with many sub-functions (immersive games). Each function is independent and dependent on each other, each game can coordinate its own closed-loop ecology, and partly interact with the main function. Such a social structure will become decentralized and look more stable and efficient.

-----------------
Note: Some of the ideas were inspired by [知 transit][1]


  [1]: https://www.zhihu.com/

{% raw %}</span>{% endraw %}
